//Program to implement multiple inheritance

#include<iostream.h>
#include<string.h>

class employee
{
 protected:
 char * name;
 short department;
 float basic;
 float da;
 employee * next;
 public:
 static employee * list;
 employee(char *n,int d,float basic,float da);
 static void print_list();
 virtual void compute_pay() const = 0;
 virtual void print() const;
 };

 employee * employee::list;
 class manager :public virtual employee
 {
  protected:
  float sp_allow;
  short level;
  public:
  manager(char *n,int l,int d,float basic,float da,float sp_allow);
  void print() const;
  void compute_pay() const;
  };

  class salesman :public virtual employee
  {
  protected:
  float comm;
  public :
  salesman(char *n,int d,float basic,float da,float comm);
  void compute_pay() const;
  };

  class salesmanager : public virtual employee,public salesman,public manager
  {
  public:
  void compute_pay() const;
  salesmanager(char *n,int d,int l,float basic,float da,float comm,float sp_allow);
  };


  void employee::print()  const
  {
  cout<<"name:"<<"\t"<<"department="<<department<<'\n';
  }

  void manager::print() const
  {
  employee::print();
  cout<<"level:"<<level<<endl;
  }

  void employee::print_list()
  {
    cout<<"------------------------------------"<<endl;
    for(employee *p =list;p;p=p->next)
    {
      p->print();
      p->compute_pay();
      cout<<"----------------------------------"<<endl;
      }
    }

    manager::manager(char *n,int d ,int l,float basic,float da,float spa) :employee(n,d,basic,da)
    {
    level=l;
    sp_allow = spa;
    }
    salesmanager::salesmanager(char *n,int d,int l,float basic,
                                float da,float spa,float comm)
                                :salesman(n,d,basic,da,comm),
                                manager(n,d,l,basic,da,spa),
                                employee(n,d,basic,da)
                                {//no members to initialize
                                }
   void manager::compute_pay() const
   {
   float tot_pay;
   tot_pay=basic+da+sp_allow;
   cout<<"the total salary of"<<name<<"is"<<tot_pay<<endl;
   }
   salesman::salesman(char *n,int d,float basic,float da,float comm):employee(n,d,basic,da)
                        {
                         salesman::comm=comm;
                         }
                         void salesman::compute_pay() const
                         {
                          float tot_pay;
                         tot_pay =basic+da+comm;
                         cout<<"the total salary of "<<name<<"is"
                                       <<tot_pay<<endl;
                          }


void salesmanager::compute_pay() const
{
   float tot_pay;
  tot_pay = basic+da+comm+sp_allow;
  cout<<"the total salary of "<<name<<"is"<<tot_pay<<endl;
  }

  employee::employee(char *n,int d,float basic,float da)
  {
   name = new char[strlen(n)+1];
   strcpy(name,n);
   department=d;
   employee::basic=basic;
   employee ::da=da;
   next=list;  //maintain a linked list
   list = this;
   }
   //-----------------------------------------------------

   void main(void)
   {
   manager m("girish",2,2,3000,2000,2000);
   salesman v("mahesh",2,3000,2000,1000);
   salesmanager s("raju",3,2,3000,4000,2000,1000);
   employee::print_list();
   }
   //---------------------end of main program






