PROGRAM 6: Find the words from a given input string and display
	   the number of words.

//Program to parse the input string and display each words in it
//It is a classic example of finite state machine.

#include<iostream.h>
#include<ctype.h>
#include<string.h>
#include<stdio.h>
#include<conio.h>

class parser
{
public :
       static void set_counter();
       static int get_counter();
       virtual parser *next(char)=0;

protected :
       static parser *non_word_ptr;
       static parser *word_ptr;
       static int counter;

};

//----------------end of class declarations-----------------

inline void parser::set_counter()
{
counter=0;
}

//----------------------------------------------------
inline int parser ::get_counter()
{
return counter;
}
//----------------------------------------------------
class non_word_state:public parser
{
   public:
	 virtual parser *next(char ch);
};
//----------------------------------------------------
parser *non_word_state::next(char ch)
{
 //If letter or digit is detected then it represents the start of
 // the word. Simply add to the count of words and switch to the
 // word state.

 if ((isalnum(ch) != 0) || (ch=='-'))
 {
 cout<<ch;
 ++counter;
 return word_ptr;
 }
 //remain in the same state if we are not passing a letter/digit

 return non_word_ptr;
 }
//----------------------------------------------------
 class word_state:public parser
 {
 public :
 virtual parser *next(char ch);
 };
//----------------------------------------------------
 parser *word_state::next(char ch)
 {
 //if letter or digit is found then output it and remain
 // in the same state

 if(isalnum(ch) !=0 || ch=='_')
 {
 putchar(ch);
 return word_ptr;
 }

 // else, a non letter/digit is found, terminate the current word
 // and switch to the non word state
 cout<<endl;
 return non_word_ptr;
 }
//----------------------------------------------------
 parser *parser ::non_word_ptr = new non_word_state ;
 parser *parser ::word_ptr = new word_state;
 int parser ::counter;

 class my_class
 {
 parser *ptr_present_state;
 enum {size = 128 };
 char buffer[size];
 public :
 my_class();
 ~my_class();
  void process(char *);
 };
//----------------------------------------------------
 inline my_class ::my_class()
 {
 ptr_present_state=new non_word_state;
 }
 inline my_class::~my_class()
 {
 delete ptr_present_state;
 }
//----------------------------------------------------
 void my_class ::process(char buffer[])
 {
 parser::set_counter();
 int i;
 for(i=0;i<=strlen(buffer);i++)
 {
 char ch=buffer[i];
 ptr_present_state=ptr_present_state->next(ch);
 }
 int total=parser::get_counter();
 cout<<total<<" words ";
 }
//----------------------------------------------------
 void main(void)
 {
 my_class o1;
 int size=128;
 char buffer1[128];
 char ans='y';

  clrscr();
  while(ans=='y')
 {
 cout<<"\n\t\t enter a string ";
 fgets(buffer1,size,stdin);
 o1.process(buffer1);
 cout<<"\n Want to try any more ";
 ans=getch();
 }
 }

//------------------------end of main----------------
