
;Design Of Line Editor
;Problem Statement :
;To design a LINE EDITOR for providing the facility in the program modification, insertion and deletion
;Overview of Line Editors :
;The line editor supports editing operations whose basic unit is a line. The basic limitation of such editors is that part of line cannot be processed and that the text to be edited has to be explicitly addressed. Another facility permitted a relative line specification.
;Facilities Provided by the Line Editor :

;Creating a new file.
;* Display an existing file.
;* Editing a file
;* Inserting a line.
;* Deleting a line 
;* Modifying a line.
;Algorithm
;* Display the main menu.
;* Accept users choice.
;* Perform requested function.
;* If choice is exit, then stop, else goto step 1.
;Creating a New File :
;* Request user for filename.
;* Create file
;* Accept user entries on single line till '#' is encountered.
;* Write lines to file.
;* Close file, return to main menu.
;Display a File :
;* Request user for filename.
;* Print file line by line till a null character is encountered.
;* Wait for user to return to main menu by pressing a key or giving a delay.
;* Close file and return.
;Edit Lines :
;* Display edit choices.
;* Open file specified by user.
;* Accept user choice and call correct routine.
;* Give options to continue editing some file or newfile.
;* Return to main menu.
;Insert Line :
;* Request user for line number where insertion is required.
;* Transfer line from source file to temporary file till insertion point is reached.
;* Input line to be inserted and write to temporary file. Write remaining lines to temp. file.
;* Transfer temporary file to user file.
;* Close file and return to main menu.
;Delete Line :
;* Request user for line number to be deleted.
;* Transfer line from source file to temporary file till insertion point is reached.
;* Omit one line i.e. the line to be deleted.
;* Write remaining lines to temp file.
;* Transfer temporary file to user file.
;* Close file and return to main menu.
;Modify Line :
;* Request user for line number where modification is required.
;* Transfer line from source file to temporary file till insertion point is reached.
;* Omit the old line.
;* Input new line to be inserted and write to temporary file.
;* Write remaining lines to temp file.
;* Transfer temporary file to user file.
;* Close file and return to main menu.


;Line Editor Using Lisp
	; Here whatever is on the line following semicolon ( ; ) is comment.
(setq FileName  "")
(setq LineCount  0)
(setq EPtr  0)
(setq MaxLineCount  0)
(setq LineNum  0)
; (setq [<sym><expr>]...) SET THE VALUE OF A SYMBOL
; <sym> the symbol being set (quoted)
; <expr> the new value
; returns the new value
; -----------------------------
(
defun Cls ( )
(  dos "cls"  )
	)
; ------------------------------
	(	
	defun CreateFile ()
		( princ "\nFile not found.")
		( princ "\nA new file was created.")
		( setf   FPtr (openo FileName))
		( princ "\n")
		( dos "pause")
	)
	; ( 	princ <expr> [<sink>]) PRINT A LIST OF VALUES WITHOUT
	;	QUOTING
	;	<expr> the expressions to be printed
	;	<sink> the output sink (default is standard output) 
	;	returns the expression
	;	( setf   [<place> <expr>]...) SET THE VALUE OF 
	;	A FIELD
	;	<place> the field specifier (quoted):
	;	<sym> set value of a symbol
	;	(car <expr>) set car of a list node
	;	(cdr <expr>) set cdr of a list node
	;	(nth <n> <expr>) set nth car of a list
	;	(aref <expr> <n>) set nth element of an array
	;	(get <sym> <prop>) set value of a property
	;	(symbol-value <sym>) set value of a symbol
	;	(symbol-plist <sym>) set property list of a
	;	symbol
	;	<value> the new value
	;	returns the new value
	;	(openi <fname>) OPEN AN INPUT FILE	
	;	<fname> the file name string or symbol
	;	returns a file pointer
	;	(openo <fname>) OPEN AN OUTPUT FILE
	;	<fname> the file name string or symbol
	;	returns a file pointer
	;	--------------------------------
(
	defun OpenFile ()
		(princ "\nEnter FileName : ")
		(read-line)
		(setq FileName (read-line))
		(setf  FPtr (openi FileName))
		(if 	(eql FPtr nil)
			(CreateFile)
		)
		( close FPtr )
;	(if <texpr> <expr1> [<expr2>]) EXECUTE EXPRESSIONS
	;	CONDITIONALLY
	;	<texpr> the test expression
	;	<expr1> the expression to be evaluated if texpr is
	;	non-nil
	;	<expr2> the expression to be evaluated if texpr 
	;	is nil
	;	returns the value of the selected expression
	;	(eql <expr1> <expr2>) 	ARE THE EXPRESSIONS 
	;	DENTICAL ?
	;	(WORKS WITH NUMBERS AND STRINGS)
	;	<expr1> 	the first expression
	;	<expr2> 	the second expression
	;	returns 	t if they are equal, nil otherwise
	;	(defun <sym> <fargs> [<expr>]...) DEFINE A FUNCTION
	;	(defmacro <sym> <fargs> [<expr>]...) DEFINE A MACRO
	;	<sym> 	symbol being defined (quoted)
	;	<fargs> 	list of formal arguments (quoted)
	;			this list is of the form :
	;			([<farg>]...
	;			[& optional [<oarg>]...]
	;			[&rest <rarg>]
	;			[&aux [<aux>]...])
	;			where
	;			<farg>	 is a formal argument
	;			<oarg> 	is an optional argument
	;			<rarg> 	bound to the rest of the arguments 
	;			<aux> 	is an auxiliary variable
	;	<expr>	expressions constituting the body of the 
	;			function (quoted)
	;	returns 	the function symbol
	;	(read-line [<source>]) 	READ A LINE FROM A FILE OR 
	;	TREAM
	;	<source> 	the input source (default is standard input)
	;	returns 	the input string
	;	(close <fp>)	CLOSE A FILE
	;	<fp> 	the file pointer
	;	returns 	nil
	;	--------------------------------
(
defun OpenFileR ( )
	( setf  FPtr (openi FileName))
	( if (eql FPtr nil)
		( princ "\nFile Could Not Be Opened !\n")
)
)
;--------------------------------
(
defun OpenFileW ()
	( setf  FPtr (openo FileName))
	( if (eql FPtr nil)
		( princ "\nFile Could Not Be Opened !\n")
	)
)
;--------------------------------(
defun CloseFile ()
	( close FPtr)
)
;--------------------------------
(
defun ViewFile ()
	( OpenFileR)
	( setf  LineCount 0)
	( setf  sLine "")
	( setf  sLine (read-line FPtr))
	( do 	((eof 0)) ((eql eof 1))
		( setf  LineCount (1+ LineCount))
		( princ "Line [")
		( princ LineCount)
		( princ "] : ")
		( princ sLine)
		( princ "\n")
		( setq sLine (read-line FPtr))
		( if 	(null sLine)
			(setf  eof 1)
		)
	)
	( setf  LineCount (1+ LineCount))
	( setq MaxLineCount LineCount)
	( CloseFile)
	( princ "\n")
	( dos "pause")
)
;	(do ([<binding>]...) (<texpr> [<rexpr>]...) [<expr>]...)
;	<binding> the variable bindings each of which is either :
;	(1) 	a symbol (which is initialized to nil)
;	(2) 	a list of the form: (<sym> <init> [<step>])
;		where :
;			<sym> is the symbol to bind
;			<init> is the initial value of the symbol
;			<step> is a step expression
;	<texpr> 	the termination test expression
;	<rexpr> 	result expressions (the default is nil)
;	<expr> 	the body of the loop (treated like an implicit
;	prog)
;	returns 	the value of the last result expression
;	(1+<expr>) ADD ONE TO A NUMBER
;	<expr> 	the number
;	returns 	the number plus one
;	--------------------------------
(
defun InsertLine ( )
	(OpenFileR)
	(setq sNewLine "")
	(princ "\n Enter the new line :")
	(read-line)
	(setq sNewLine (read-line))
	(setf  TempFP (openo "Temp. $___"))
		; Skip lines till current line num is reached
(do ((Count 1 (1+ Count))) ((eql Count LineNum))
		(setf  sLine (read-line FPtr))
		(princ sLine TempFP)
		(princ "\n" TempFP)
	)
(princ sNewLine TempFP) ; Write the inserted line 
	(princ "\n" TempFP)
; Write the remaining lines into a temp file
	(setq sLine (read-line FPtr))
	(do ((eof 0)) ((eql eof 1))
		(princ sLine TempFP)
		(princ "\n" TempFP)
		(setq sLine (read-line FPtr))
		(  if 	(null sLine)
			(setf  eof 1)
		)
	)
	; ( CloseFile)
	  ( close TempFP)
(setq DosCmd (strcat "del " FileName ">nul:"))
	(dos DosCmd)
(setq DosCmd (strcat "rename " "Temp.$___ " FileName ">nul :"))
	(dos DosCmd)
	)
;	--------------------------------
(
defun DeleteLine ()
	(OpenFileR)
	(setq sNewLine "")
	(setf  TempFP (openo "Temp.$___ "))
; Skip lines till current line num is reached
(do ((Count 1 (1+ Count))) ((eql Count LineNum))
		(setf  sLine (read-line FPtr))
		(princ sLine TempFP)
		(princ "\n" TempFP)
	)
; (princ sNewLine TempFp) ; Write the inserted line 
	; (princ "\n" TempFP)
	(setf  sLine (read-line FPtr))
	; Write the remaining lines into a temp file 
	( do ((eof 0)) ((eql eof 1))
		(setq sLine (read-line FPtr))
		(princ sLine TempFP)
		(princ "\n" TempFP)
		(  if 	(null sLine)
			(setf  eof 1)
		)
	)
	; (CloseFile)
	(close TempFP)
	(setq DosCmd (strcat "del " FileName ">nul:"))
		(dos DosCmd)
(setq DosCmd (strcat "rename " "Temp.$___ " FileName ">nul:"))
		(dos DosCmd)
	)
;	--------------------------------
(
defun InsertAt ()
	(ViewFile)
	(princ "\n Enter the line no. at which to be inserted :")
		(setq LineNum (read))
		(if (> LineNum MaxLineCount)
		(princ "Line no. exceeds num of lines in file.")
	)
	(InsertLine)
)
;--------------------------------
(
defun DeleteAt ()
	(ViewFile)
	(princ "\n Enter the line no. to be deleted :")
	(setq LineNum (read))
	(  if 	(> LineNum MaxLineCount)
		(princ "Line no. exceeds num of lines in file.")
	)
	(DeleteLine)
)
;--------------------------------
(
defun ModifyAt ()
	(ViewFile)
	(princ "\n Enter the line no. to be Modified :")
	(setq LineNum (read))
	(  setq TempLineNum LineNum)
	(   if 	( > LineNum MaxLineCount)
		(princ "Line no. exceeds num of lines in file.")
	)
	(DeleteLine)
	(setq LineNum TempLineNum)
	(InsertLine)
)
;(> 	<e1>  <e2>) TEST FOR GREATER THAN
;	<e1> 		the left operand of the comparison
;	<e2> 		the right operand of the comparison
;	returns 	the result of comparing <e1> with <e2>
;--------------------------------
(
defun Menu ()
(setq Flag '1)
(do 	((i 0 (1+ i))) ((eql Flag '6))
	(cls)
		(princ  "\n Line Editor ")
		(princ "\n  -----------------------------------")
		(princ "\n")
		(princ "\n  1 : Open File ")
		(princ "\n  2 : View File ")
		(princ "\n  3 : Insert Line")
		(princ "\n  4 : Delete Line")
		(princ "\n  5 : Modify Line")
		(princ "\n  6 : Exit To DOS")
		(princ "\n  Enter Choice : ")
		(setq Flag (read))
		(case Flag
			(1 (OpenFile))
			(2 (ViewFile))
			(3 (InsertAt))
			(4 (DeleteAt))
			(5 (ModifyAt))
			(6 (exit))
		)
	)
)
;--------------------------------
	(cls)
	(Menu)
(exit)
;(exit) -> To exit program and return control to DOS
;--------------------------------


